Related:
Leetcode 495 - Teemo Attacking
LeetCode - 649 Dota2 Senate
https://leetcode.com/problems/teemo-attacking/
一趟遍历即可,详见代码。
X.
https://discuss.leetcode.com/topic/77100/easy-to-understand-java-solution
LeetCode果然花样百出,连提莫都搬上题目了,那个草丛里乱种蘑菇的小提莫,那个“团战可以输提莫必须死”的提莫??可以,服了,坐等女枪女警轮子妈的题目了~好了,不闲扯了,其实这道题蛮简单的,感觉不能算一道medium的题,就直接使用贪心算法,比较相邻两个时间点的时间差,如果小于duration,就加上这个差,如果大于或等于,就加上duration即可
Leetcode 495 - Teemo Attacking
LeetCode - 649 Dota2 Senate
https://leetcode.com/problems/teemo-attacking/
In LLP world, there is a hero called Teemo and his attacking can make his enemy Ashe be in poisoned condition. Now, given the Teemo's attacking ascending time series towards Ashe and the poisoning time duration per Teemo's attacking, you need to output the total time that Ashe is in poisoned condition.
You may assume that Teemo attacks at the very beginning of a specific time point, and makes Ashe be in poisoned condition immediately.
Example 1:
Input: [1,4], 2 Output: 4 Explanation: At time point 1, Teemo starts attacking Ashe and makes Ashe be poisoned immediately. This poisoned status will last 2 seconds until the end of time point 2. And at time point 4, Teemo attacks Ashe again, and causes Ashe to be in poisoned status for another 2 seconds. So you finally need to output 4.
Example 2:
Input: [1,2], 2 Output: 3 Explanation: At time point 1, Teemo starts attacking Ashe and makes Ashe be poisoned. This poisoned status will last 2 seconds until the end of time point 2. However, at the beginning of time point 2, Teemo attacks Ashe again who is already in poisoned status. Since the poisoned status won't add up together, though the second poisoning attack will still work at time point 2, it will stop at the end of time point 3. So you finally need to output 3.
Note:
- You may assume the length of given time series array won't exceed 10000.
- You may assume the numbers in the Teemo's attacking time series and his poisoning time duration per attacking are non-negative integers, which won't exceed 10,000,000.
一趟遍历即可,详见代码。
X.
https://discuss.leetcode.com/topic/77100/easy-to-understand-java-solution
We just need to take the minimum value between the difference of previous timestamp and the current timestamp, and the duration.
This makes sense because the poisoning will happen at each timestamp.
At the end, I am adding the duration to the total answer to take in consideration the poisoning at the last timestamp.
This makes sense because the poisoning will happen at each timestamp.
At the end, I am adding the duration to the total answer to take in consideration the poisoning at the last timestamp.
public int findPosisonedDuration(int[] timeSeries, int duration) {
if(timeSeries.length == 0)return 0;
if(timeSeries.length == 1)return duration;
int total = 0;
for(int i=1; i<timeSeries.length;i++)
{
total += Math.min(duration,timeSeries[i]-timeSeries[i-1]);
}
total += duration;
return total;
}
https://discuss.leetcode.com/topic/77067/java-7-lines-o-n-solution
For each
If
If
In both cases update
begin
followed by t
If
t
is within previous duration [begin, begin + duration]
then increase total by t - begin
If
t
in out of previous duration [begin, begin + duration]
then increase total by duration
In both cases update
begin
to the new begin time t
public int findPoisonedDuration(int[] timeSeries, int duration) {
if (timeSeries.length == 0) return 0;
int begin = timeSeries[0], total = 0;
for (int t : timeSeries) {
total = total + (t < begin + duration ? t - begin : duration);
begin = t;
}
return total + duration;
}
X. https://discuss.leetcode.com/topic/77071/o-n-java-solution-using-same-idea-of-merge-intervals
The same idea as https://leetcode.com/problems/merge-intervals/
Algorithm:
Algorithm:
- Use two variable to record current start and end point.
- If the start of new interval is greater than current end, meaning NO overlapping, we can sum the current interval length to result and then update start and end.
- Otherwise just update the current end;
public int findPosisonedDuration(int[] timeSeries, int duration) {
if (timeSeries == null || timeSeries.length == 0 || duration == 0) return 0;
int result = 0, start = timeSeries[0], end = timeSeries[0] + duration;
for (int i = 1; i < timeSeries.length; i++) {
if (timeSeries[i] > end) {
result += end - start;
start = timeSeries[i];
}
end = timeSeries[i] + duration;
}
result += end - start;
return result;
}
https://www.cnblogs.com/grandyang/p/6399408.htmlLeetCode果然花样百出,连提莫都搬上题目了,那个草丛里乱种蘑菇的小提莫,那个“团战可以输提莫必须死”的提莫??可以,服了,坐等女枪女警轮子妈的题目了~好了,不闲扯了,其实这道题蛮简单的,感觉不能算一道medium的题,就直接使用贪心算法,比较相邻两个时间点的时间差,如果小于duration,就加上这个差,如果大于或等于,就加上duration即可
int findPoisonedDuration(vector<int>& timeSeries, int duration) { if (timeSeries.empty()) return 0; int res = 0, n = timeSeries.size(); for (int i = 1; i < n; ++i) { int diff = timeSeries[i] - timeSeries[i - 1]; res += (diff < duration) ? diff : duration; } return res + duration; }